/******************************************************************************
 * playtone.hpp
 * CoreTone Auditioning Suite for Windows.
 *-----------------------------------------------------------------------------
 * Copyright (C) 2015 - 2016 Osman Celimli
 * For conditions of distribution and use, see copyright notice in playtone.cpp
 ******************************************************************************/
#ifndef PLAYTONE
#define PLAYTONE

/* ---- HELPERS ----
 *----------------------------------------------------------------------------*/
/* VS6's Commctrl doesn't provide a #def for "STATIC" window classes,
 * this was added as "WC_STATIC" in later versions.
 */
#ifndef WC_STATIC
	#define WC_STATIC					_T("STATIC")
#endif

#ifndef WC_BUTTON
	#define WC_BUTTON					_T("BUTTON")
#endif


typedef struct Icon_s
{
	INT iCon;
	HICON hCon;
} Icon_t;


typedef void (*buttonCall_t)(HWND hButton);

typedef struct Button_s
{
	HWND hWnd;
	buttonCall_t pCall;
} Button_t;


/* ---- INCLUDE SET ----
 *----------------------------------------------------------------------------*/
#include "../types.h"
#include "../bupboop.h"
extern "C" {
	#include "../CoreTone/coretone.h"
	#include "../CoreTone/sample.h"
	#include "../CoreTone/channel.h"
	#include "../CoreTone/music.h"
}

#include "bupman.hpp"

#include "resource.h"
#include "menuman.hpp"
#include "statman.hpp"
#include "waveman.hpp"
#include "panelman.hpp"

#include "patchpop.hpp"
#include "musicpop.hpp"
#include "effectpop.hpp"


/* ---- OPERATING PARAMETERS ----
 *----------------------------------------------------------------------------*/
#define MAIN_WINDOW_WIDTH		400
#define MAIN_WINDOW_HEIGHT		144

#define MAIN_WAVE_XPOS			228
#define MAIN_WAVE_YPOS			0
#define MAIN_WAVE_WIDTH			160
#define MAIN_WAVE_HEIGHT		60

#define MAIN_STAT_XPOS			8
#define MAIN_STAT_YPOS			0
#define MAIN_STAT_WIDTH			208
#define MAIN_STAT_HEIGHT		60

#define MAIN_PANEL_XPOS			0
#define MAIN_PANEL_YPOS			64


/* ---- GLOBALS AND EXTERNS ----
 *----------------------------------------------------------------------------*/
/* Timing Parameters
 *-----------------------------------*/
#define DRAW_TIMER_ID			101
#define DRAW_TIMER_MS			50


/* Main Window and Friends
 *-----------------------------------*/
extern const TCHAR szEmpty[];
extern const TCHAR szTerms[];

extern HWND hMainWnd;
extern UINT_PTR pDrawTimer;

extern BOOL bFocus,bMinimized;

extern BupMan *pBupMan;

extern MenuMan *pMenuMan;
extern WaveMan *pWaveMan;
extern StatMan *pStatMan;
extern PanelMan *pPanelMan;

extern PatchPop *pPatchPop;
extern MusicPop *pMusicPop;
extern EffectPop *pEffectPop;

#endif
