/******************************************************************************
 * waveman.hpp
 * Dot matrix of questionable quality stereo sound.
 *-----------------------------------------------------------------------------
 * Copyright (C) 2015 - 2016 Osman Celimli
 * For conditions of distribution and use, see copyright notice in playtone.cpp
 ******************************************************************************/
#ifndef WAVEMAN
#define WAVEMAN

/******************************************************************************
 * Layout
 ******************************************************************************/
/* Control IDs
 *-----------------------------------*/
#define WAVEMAN_ID_BASE					8000
#define WAVEMAN_ID_BORDER				(WAVEMAN_ID_BASE + 0)


/******************************************************************************
 * Class
 ******************************************************************************/
class WaveMan {
	public:
		WaveMan(HWND hParent, INT iX, INT iY, INT iW, INT iH);
		~WaveMan(void);

		void renderWave(HDC hDCm, COLORREF crLeft, COLORREF crRight,
						COLORREF crMerge);

		LRESULT paintProc(HWND hWnd, HDC hDC, PAINTSTRUCT psWin);
		LRESULT invalProc(HWND hWnd);

	private:
		HWND mhParent;

		HWND mhBorder;
		INT miX,miY;
		INT miWidth,miHeight;

		HBITMAP mhWaveMap;
		HDC mhDCm;
};

#endif
